<?php include("inc/pagestart.php"); ?>
<?php include("inc/header.php"); ?>
<?php include("inc/contentstart.php"); ?>

<?php
  class wiki_parser {
    var $parser;
    var $data = array();
    var $curtag = "";

    function startElement($parser, $name, $attrs)
    {
      $this->curtag = $name;
      $this->data[$name] = '';
    }

    function endElement($parser, $name)
    {
    }

    function characterData($parser, $cdata)
    {
      $this->data[$this->curtag] .= $cdata;
    }

   function wiki_parser()
   {
      $this->parser = xml_parser_create();
      xml_set_object($this->parser, $this);
      xml_set_element_handler($this->parser, "startElement", "endElement");
      xml_set_character_data_handler($this->parser, "characterData");
   }

   function parse($data) {
      xml_parse($this->parser, $data);
      return $this->data;
   }
  }

  // Adapted from mediawiki skin.php around line 1518
  function wiki_anchor($headline)
  {
    $anchor = urlencode(str_replace(' ', '_', trim($headline)));
    $replacearray = array(
      '%3A' => ':',
      '%' => '.'
    );
    $u = str_replace(array_keys($replacearray),array_values($replacearray),$anchor);

    return $u;
  }

	print('Updating...');

    exec('wget -O /tmp/comm.html http://taspring.clan-sy.com/wiki/Special:Export/Community_news');

  //$data = file_get_contents('http://taspring.clan-sy.com/wiki/Special:Export/Community_news');
  $data = file_get_contents('/tmp/comm.html');

  $parser = new wiki_parser();

  $xml = $parser->parse($data);

//  print_r($xml);
//  print($xml['TEXT']);


  $headlines = array();
  preg_match_all('/===(.*)===/', $xml['TEXT'], $headlines);

  $f = fopen('community.xml', 'w');
  fwrite($f, '<?xml version="1.0" encoding="iso-8859-1"?>' . "\n");
  fwrite($f, '<rss version="0.91">' . "\n");
  fwrite($f, '  <channel>' . "\n");
  fwrite($f, '    <title>TA Spring Community News</title>' . "\n");
  fwrite($f, '    <link>http://taspring.clan-sy.com/</link>' . "\n");
  fwrite($f, '    <description>Community-posted news</description>' . "\n");

  $curofs = 0;
  foreach ($headlines[1] as $hl) {

    if ($hl{0} == '=')
    	continue;

    $hl = trim($hl);
    $hl = substr($hl, 0, 50);

    $btextstart = strpos($xml['TEXT'], $hl, $curofs);
    if ($btextstart !== false) {
	    $curofs = $btextstart + 5;	// just start again a bit after it

        $btext = substr($xml['TEXT'], $btextstart, 650);    // should be enough. hyper-long links could break it

        $realstart = strpos($btext, '===');
        $btext = substr($btext, $realstart + 3);

        // stop at first linebreak or at max 150 chars
        $btext = trim($btext);

        $totout = 0;
        $curin = 0;
        $outstr = "";
        $state = 0;
        $done = false;
        while (!$done) {
            $c = $btext{$curin};
            $curin++;
            switch ($state) {
                case 0:
                    if ($c == "\n") {
                        $done = true;
                        break;
                    }
                    if ($c == "[") {
                        $state = 1;
                    }
                    $outstr .= $c;
                    $totout++;
                    break;
                case 1:
                    if ($c == "]") {
                        $state = 0;
                    }
                    if ($c == " ") {
                        $state = 2;
                    }
                    $outstr .= $c;
                    break;
                case 2:
                    if ($c == "]") {
                        $state = 0;
                    }
                    $outstr .= $c;
                    $totout++;
                    break;
            }

            if ($totout >= 150) {
                $outstr .= "...";
                if ($state > 0)
                    $outstr .= ']';
                $done = true;
            }
        }

        $btext = $outstr;
        $btext = htmlspecialchars($btext);

/*        $nlstart = strpos($btext, "\n");
        if ($nlstart !== false) {
            $btext = substr($btext, 0, $nlstart);
        }
        else {
            $btext .= "...";
        } */

      // parse wikilinks
/*      $btext = htmlspecialchars($btext);
		  preg_match_all('/\[\[(.*)\]\]/', $btext, $wlinks);
      foreach ($wlinks[1] as $wtext) {
        $wlink = str_replace(' ', '_', $wtext);
      	$newlink = '<a href="http://taspring.clan-sy.com/wiki/' . $wlink . '">' . $wtext . '</a>';
        $btext = str_replace("[[$wtext]]", $newlink, $btext);
      } */

//      print_r($wlinks);
    }

  	fwrite($f, '    <item>' . "\n");
    fwrite($f, '      <title>' . htmlspecialchars($hl) . '</title>' . "\n");
    fwrite($f, '      <link>http://taspring.clan-sy.com/wiki/Community_news#' . wiki_anchor($hl) . '</link>' . "\n");
    fwrite($f, '      <description>' . $btext . '</description>' . "\n");
    fwrite($f, '    </item>' . "\n");
  }

  fwrite($f, '  </channel>' . "\n");
  fwrite($f, '</rss>' . "\n");

  fclose($f);

  print(' done.');
?>

<?php include("inc/contentend.php"); ?>
<?php include("inc/footer.php"); ?>
<?php include("inc/pageend.php"); ?>